Loading...
Searching...
No Matches
geo_element_auto< A >

## Detailed Description

template<class A = std::allocator<std::vector<int>::size_type>>
class rheolef::geo_element_auto< A >

Definition at line 376 of file geo_element.h.

Inheritance diagram for geo_element_auto< A >:

## Public Types

typedef A | allocator_type
typedef reference_element::size_type | size_type
typedef reference_element::variant_type | variant_type
typedef geo_element::iterator | iterator
typedef geo_element::const_iterator | const_iterator
typedef geo_element::parameter_type | parameter_type
typedef geo_element | generic_type
typedef geo_element::automatic_type | automatic_type
Public Types inherited from geo_element
enum | { _variant_offset = 0 , _order_offset = 1 , _dis_ie_offset = 2 , _ios_dis_ie_offset = 3 , _master_offset = 4 , _last_offset = 6 }
typedef reference_element::size_type | size_type
typedef reference_element::variant_type | variant_type
typedef size_type * | iterator
typedef const size_type * | const_iterator
typedef size_type | raw_type
typedef geo_element | generic_type
typedef geo_element_auto< heap_allocator< size_type > > | automatic_type
typedef geo_element_indirect::orientation_type | orientation_type
typedef geo_element_indirect::shift_type | shift_type

## Public Member Functions

| geo_element_auto (const A &alloc=A())
| geo_element_auto (variant_type variant, size_type order=1, const A &alloc=A())
| geo_element_auto (parameter_type p, const A &alloc=A())
| geo_element_auto (const geo_element &K)
| geo_element_auto (const geo_element_auto< A > &K)
template<class A2 >
| geo_element_auto (const geo_element_auto< A2 > &K)
const geo_element_auto< A > & | operator= (const geo_element &K)
void | reset (variant_type variant, size_type order)
void | reset (const parameter_type &param)
template<class Archive >
void | serialize (Archive &ar, const unsigned int version)
iterator | _data_begin ()
const_iterator | _data_begin () const
iterator | _data_end ()
const_iterator | _data_end () const
Public Member Functions inherited from geo_element
geo_element & | operator= (const geo_element &K)
virtual | ~geo_element ()
| operator reference_element () const
variant_type | variant () const
size_type | order () const
size_type | dis_ie () const
size_type | ios_dis_ie () const
size_type | master (bool i) const
size_type | dimension () const
size_type | size () const
char | name () const
size_type | n_node () const
void | set_dis_ie (size_type dis_ie)
void | set_ios_dis_ie (size_type ios_dis_ie)
void | set_master (bool i, size_type dis_ie) const
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
size_type & | operator[] (size_type loc_inod)
size_type | operator[] (size_type loc_inod) const
size_type & | node (size_type loc_inod)
size_type | node (size_type loc_inod) const
iterator | begin (size_type node_subgeo_dim)
const_iterator | begin (size_type node_subgeo_dim) const
iterator | end (size_type node_subgeo_dim)
const_iterator | end (size_type node_subgeo_dim) const
const geo_element_indirect & | edge_indirect (size_type i) const
const geo_element_indirect & | face_indirect (size_type i) const
geo_element_indirect & | edge_indirect (size_type i)
geo_element_indirect & | face_indirect (size_type i)
size_type | edge (size_type i) const
size_type | face (size_type i) const
size_type | n_subgeo (size_type subgeo_dim) const
size_type | subgeo_dis_index (size_type subgeo_dim, size_type i) const
size_type | subgeo_n_node (size_type subgeo_dim, size_type loc_isid) const
size_type | subgeo_local_node (size_type subgeo_dim, size_type loc_isid, size_type loc_jsidnod) const
size_type | subgeo_size (size_type subgeo_dim, size_type loc_isid) const
size_type | subgeo_local_vertex (size_type subgeo_dim, size_type i_subgeo, size_type i_subgeo_vertex) const
size_type | first_inod (size_type subgeo_dim) const
size_type | last_inod (size_type subgeo_dim) const
size_type | n_edge () const
size_type | n_face () const
orientation_type | get_side_informations (const geo_element &S, size_type &loc_isid, size_type &shift) const
void | get_side_informations (const geo_element &S, side_information_type &sid) const
orientation_type | get_side_orientation (const geo_element &S) const
bool | get_orientation_and_shift (const geo_element &S, orientation_type &orient, shift_type &shift) const
| return orientation and shift between *this element and S
orientation_type | get_edge_orientation (size_type dis_iv0, size_type dis_iv1) const
void | get_orientation_and_shift (size_type dis_iv0, size_type dis_iv1, size_type dis_iv2, orientation_type &orient, shift_type &shift) const
void | get_orientation_and_shift (size_type dis_iv0, size_type dis_iv1, size_type dis_iv2, size_type dis_iv3, orientation_type &orient, shift_type &shift) const
void | put (std::ostream &is) const
void | get (std::istream &os)
size_type | _data_size () const
template<class Archive >
void | serialize (Archive &ar, const unsigned int version)
void | setname (char name)
char | name () const
size_t | variant () const
size_t | dimension () const
size_t | n_vertex () const
size_t | size () const
| geo_element ()
void | setname (char name)
void | setorder (size_t order)
void | setindex (size_t index)
void | setgmshtype (size_t gmshtype)
geo_element_indirect & | edge_indirect (size_t i)
geo_element_indirect & | face_indirect (size_t i)
char | name () const
size_t | order () const
size_t | index () const
size_t | gmshtype () const
size_t | variant () const
size_t | dimension () const
size_t | n_vertex () const
const geo_element_indirect & | edge_indirect (size_t i) const
const geo_element_indirect & | face_indirect (size_t i) const
size_t | n_edge () const
size_t | edge (size_t i) const
size_t | edge_local_vertex (size_t iedg, size_t edg_iv) const
size_t | face (size_t i) const
size_t | n_face () const
size_t | face_n_vertex (size_t loc_ifac) const
size_t | face_local_vertex (size_t iedg, size_t edg_iv) const
| geo_element ()

## Public Attributes

std::vector< size_type, A > | _data

## Additional Inherited Members

Static Public Member Functions inherited from geo_element
static size_type | fix_edge_indirect (const geo_element &K, size_type loc_iedg, size_type loc_iedg_j, size_type order)
static size_type | fix_edge_indirect (orientation_type orient, size_type order, size_type loc_iedg_j)
static void | loc_tri_inod2lattice (size_type loc_tri_inod, size_type order, point_basic< size_type > &ij_lattice)
static void | loc_qua_inod2lattice (size_type loc_qua_inod, size_type order, point_basic< size_type > &ij_lattice)
static size_type | fix_triangle_indirect (const geo_element &K, size_type loc_itri, size_type loc_itri_j, size_type order)
static size_type | fix_triangle_indirect (orientation_type orient, shift_type shift, size_type order, size_type loc_itri_j)
static size_type | fix_quadrangle_indirect (const geo_element &K, size_type loc_iqua, size_type loc_iqua_j, size_type order)
static size_type | fix_quadrangle_indirect (orientation_type orient, shift_type shift, size_type order, size_type loc_iqua_j)
static size_type | fix_indirect (const geo_element &K, size_type subgeo_variant, size_type loc_ige, size_type loc_comp_idof_on_subgeo, size_type order)
static size_type | _edge_offset (variant_type variant, size_type order)
static size_type | _face_offset (variant_type variant, size_type order)
static size_type | _node_offset (variant_type variant, size_type order)
static size_type | _data_size (variant_type variant, size_type order)
static size_type | _data_size (const parameter_type &p)
Protected Attributes inherited from geo_element
size_t | _variant
char | _name
size_t | _order
size_t | _index
size_t | _gmshtype
array< geo_element_indirect, 12 > | _edge
array< geo_element_indirect, 6 > | _face

## Member Typedef Documentation

## allocator_type

template<class A = std::allocator<std::vector<int>::size_type>>

typedef A allocator_type

Definition at line 381 of file geo_element.h.

## size_type

template<class A = std::allocator<std::vector<int>::size_type>>

typedef reference_element::size_type size_type

Definition at line 382 of file geo_element.h.

## variant_type

template<class A = std::allocator<std::vector<int>::size_type>>

typedef reference_element::variant_type variant_type

Definition at line 383 of file geo_element.h.

## iterator

template<class A = std::allocator<std::vector<int>::size_type>>

typedef geo_element::iterator iterator

Definition at line 384 of file geo_element.h.

## const_iterator

template<class A = std::allocator<std::vector<int>::size_type>>

typedef geo_element::const_iterator const_iterator

Definition at line 385 of file geo_element.h.

## parameter_type

template<class A = std::allocator<std::vector<int>::size_type>>

typedef geo_element::parameter_type parameter_type

Definition at line 386 of file geo_element.h.

## generic_type

template<class A = std::allocator<std::vector<int>::size_type>>

typedef geo_element generic_type

Definition at line 387 of file geo_element.h.

## automatic_type

template<class A = std::allocator<std::vector<int>::size_type>>

typedef geo_element::automatic_type automatic_type

Definition at line 388 of file geo_element.h.

## Constructor & Destructor Documentation

## geo_element_auto() [1/6]

template<class A = std::allocator<std::vector<int>::size_type>>

geo_element_auto | ( | const A & | alloc = `A()` | ) |

explicit

Definition at line 392 of file geo_element.h.

## geo_element_auto() [2/6]

template<class A = std::allocator<std::vector<int>::size_type>>

geo_element_auto | ( | variant_type | variant,
|  | size_type | order = `1`,
|  | const A & | alloc = `A()`
| ) |  |

explicit

Definition at line 398 of file geo_element.h.

## geo_element_auto() [3/6]

template<class A = std::allocator<std::vector<int>::size_type>>

geo_element_auto | ( | parameter_type | p,
|  | const A & | alloc = `A()`
| ) |  |

explicit

Definition at line 404 of file geo_element.h.

## geo_element_auto() [4/6]

template<class A = std::allocator<std::vector<int>::size_type>>

geo_element_auto | ( | const geo_element & | K | ) |

Definition at line 410 of file geo_element.h.

## geo_element_auto() [5/6]

template<class A = std::allocator<std::vector<int>::size_type>>

geo_element_auto | ( | const geo_element_auto< A > & | K | ) |

Definition at line 413 of file geo_element.h.

## geo_element_auto() [6/6]

template<class A = std::allocator<std::vector<int>::size_type>>
template<class A2 >

geo_element_auto | ( | const geo_element_auto< A2 > & | K | ) |

Definition at line 417 of file geo_element.h.

## Member Function Documentation

## operator=()

template<class A = std::allocator<std::vector<int>::size_type>>

const geo_element_auto< A > & operator= | ( | const geo_element & | K | ) |

Definition at line 420 of file geo_element.h.

## reset() [1/2]

template<class A = std::allocator<std::vector<int>::size_type>>

void reset | ( | variant_type | variant,
|  | size_type | order
| ) |  |

virtual

Implements geo_element.

Definition at line 426 of file geo_element.h.

## reset() [2/2]

template<class A = std::allocator<std::vector<int>::size_type>>

void reset | ( | const parameter_type & | param | ) |

Definition at line 431 of file geo_element.h.

## serialize()

template<class A = std::allocator<std::vector<int>::size_type>>
template<class Archive >

void serialize | ( | Archive & | ar,
|  | const unsigned int | version
| ) |  |

Definition at line 436 of file geo_element.h.

## _data_begin() [1/2]

template<class A = std::allocator<std::vector<int>::size_type>>

iterator _data_begin | ( |  | ) |

virtual

Implements geo_element.

Definition at line 443 of file geo_element.h.

## _data_begin() [2/2]

template<class A = std::allocator<std::vector<int>::size_type>>

const_iterator _data_begin | ( |  | ) | const

virtual

Implements geo_element.

Definition at line 444 of file geo_element.h.

## _data_end() [1/2]

template<class A = std::allocator<std::vector<int>::size_type>>

iterator _data_end | ( |  | ) |

virtual

Implements geo_element.

Definition at line 445 of file geo_element.h.

## _data_end() [2/2]

template<class A = std::allocator<std::vector<int>::size_type>>

const_iterator _data_end | ( |  | ) | const

virtual

Implements geo_element.

Definition at line 446 of file geo_element.h.

## Member Data Documentation

## _data

template<class A = std::allocator<std::vector<int>::size_type>>

std::vector<size_type,A> _data

Definition at line 452 of file geo_element.h.

The documentation for this class was generated from the following file:

- /build/rheolef-dTNbRN/rheolef-7.2/fem/geo_element/geo_element.h